#include <bits/stdc++.h>

using namespace std;
int a[1000000];
int main()
{
    int n,q;
    cin>>n>>q;
    
    for(int i = 0;i < n;i++)
    {
        cin>>a[i];
    }
    for(int i = 0;i<q;i++)
    {
        int l,r;
        int z;
        cin>>l>>r;
        z = l;
        l -= 1;
        r -= 1;
        for(int j = l;j < r;j++)
        {
            z = a[z]& a[j + 1];
        }
        cout<<z<<endl;;
    }
}